module NPGRT
	module Require
		def require(a)
			path = Gem.find_files(a)
			path.each{|x| yield x}
			super a
		end

		ADDPATH = []

		def binary_forms(a)
			w = NPGRT::PlatformWidth.to_s
			[ a, a+".dll", a+".so", 
     			  File.basename(a) + "_" + w + File.extname(a),
			  File.basename(a) + "_" + w + ".dll",
			  File.basename(a) + "_" + w + ".so"
			]
		end

		def require_binary(a)
			path = binary_forms(a).inject([]){|ret, v|
				ret.concat Gem.find_files v
			}
			v = path.map{|x| 
				FileTest.file?(x) ? NPGRT.normalize_pathsep_os(File.dirname(x)) : nil
			}.compact - ADDPATH
			ENV['path'] += ";" + v.join(";")
			ADDPATH.concat v
		end

		alias primitive_require require
		private :primitive_require
		
		def require(a)
		     primitive_require(a) do |x|
                        try_build  x
		     end
		end

		private

		def try_build(dir)
			dir = File.dirname dir if FileTest.file?(dir)
			system "cmd /c \"cd /d #{dir} & rake npgrt:build\""
		end

	end

end
